#ifndef DEEPSEEKAI_H
#define DEEPSEEKAI_H

#include "llm.h"
#include "uosai_global.h"

namespace uos_ai {

class DeepSeekAI : public LLM
{
    Q_OBJECT
public:
    inline QString baseUrl() {
        return QString("https://api.deepseek.com/chat/completions");
    }

    inline QString modelId() {
        return QString("deepseek-reasoner");
    }

    explicit DeepSeekAI(const LLMServerProxy &serverproxy);

    QJsonObject predict(const QString &content, const QJsonArray &functions, const QString &systemRole = "", qreal temperature = 1.0) override;
    QPair<int, QString> verify() override;

private slots:
    void onReadyReadChatDeltaContent(const QByteArray &content);
};
}
#endif // DEEPSEEKAI_H
